DATA_SECTION
  init_int n
  init_ivector year(1,n)
  init_vector C(1,n)
  init_vector I(1,n)

PARAMETER_SECTION
  init_number logr
  init_number logk
  init_number loga
  init_number logq
  init_number logsigma
  number r
  number k
  number a
  sdreport_number q
  number sigma
  vector B(1,n)
  vector Ifit(1,n)
  number RSS
  objective_function_value neglogL

PROCEDURE_SECTION
  r = mfexp(logr);
  k = mfexp(logk);
  a = mfexp(loga);
  q = mfexp(logq);
  sigma = mfexp(logsigma);
  B(1) = k * a;
  for(int t=1; t<=n-1; t++)
    B(t+1) = sfabs(B(t) + r*B(t)*(1-B(t)/k) - C(t));
  Ifit = q*B;
  RSS = sum(square(log(I)-log(Ifit)));
  neglogL = 0.5*n*log(2.0*M_PI) + n*logsigma + RSS/(2.0*square(sigma));
  if(mceval_phase())
  {
    mcmc_par<<r<<","<<k<<","<<a<<","<<q<<","<<sigma<<endl;
    mcmc_bio<<B(1);
    for(int t=2; t<=n; t++)
      mcmc_bio<<","<<B(t);
    mcmc_bio<<endl;
  }

GLOBALS_SECTION
  #include "admodel.h"
  ofstream mcmc_par("mcmc_par.csv");
  ofstream mcmc_bio("mcmc_bio.csv");
